<template>
  <div class="justify-content-center">
    <b-card
      no-body
    >
  
      <section class="invoice-add-wrapper">
        <b-row class="invoice-add d-flex justify-content-center">

          <!-- Col: Left (Invoice Container) -->
          <b-col
            cols="12"
            xl="9"
            md="8"
          >
            <validation-observer ref="simpleRules">
              <b-form @submit.prevent>
                <b-card
                  no-body
                  class="invoice-preview-card"
                >
                  <!-- Header -->
                  <b-card-body class="invoice-padding pb-0">

                    <div class="d-flex justify-content-between flex-md-row flex-column invoice-spacing mt-0">

                      <!-- Header: Left Content -->
                      <div>
                        <div class="logo-wrapper">
                          <logo />
                          <!-- <h3 class="text-primary invoice-logo">
                            Quantumbit
                          </h3> -->
                        </div>
                        <b-card-text class="mb-25">
                          Blvd. Luis Donaldo Colosio 294,
                        </b-card-text>
                        <b-card-text class="mb-25">
                          Hermosillo, Sonora, MEX
                        </b-card-text>
                        <b-card-text class="mb-0">
                          +52 662 341 4004
                        </b-card-text>
                      </div>

                      <!-- Header: Right Content -->
                      <div class="invoice-number-date mt-md-0 mt-2">
                        
                        <div class="d-flex align-items-center mb-1">
                          <span class="title">
                            Fecha de emisión:
                          </span>
                            <b-form-input
                              v-model="invoiceData.quoteDate"
                              class="form-control invoice-edit-input"
                              disabled
                            />
                        </div>
                      </div>
                    </div>
                  </b-card-body>

                  <!-- Spacer -->
                  <hr class="invoice-spacing">

                  <!-- Invoice Client & Payment Details -->
                  <b-card-body
                    class="invoice-padding pt-0"
                  >
                    <b-row class="invoice-spacing">

                      <!-- Col: Invoice To -->
                      <b-col
                        cols="12"
                        xl="6"
                        class="mb-lg-1"
                      >
                        <div class="mt-2">
                          <!-- Select Client -->
                          <b-form-group
                            label="Factura para"
                            label-for="client"
                          >
                            <validation-provider
                              #default="{ errors }"
                              name="cliente"
                              rules="required"
                            >
                              <v-select
                                v-model="selectedClient"
                                :options="clients"
                                label="name"
                                :state="errors.length > 0 ? false:null"
                                @input="getProjects(selectedClient.id)"
                                :clearable="false"
                              >
                              </v-select>
                              <small class="text-danger">{{ errors[0] }}</small>
                            </validation-provider>
                            
                          </b-form-group>
                          
                          <!-- Select Project -->
                          <b-form-group
                            label="Proyecto"
                            label-for="project"
                          >
                            <validation-provider
                              #default="{ errors }"
                              name="proyecto"
                              rules="required"
                            >
                              <v-select
                                v-model="invoiceData.project"
                                :options="projects"
                                label="name"
                                :state="errors.length > 0 ? false:null"
                                @input="getActivities(invoiceData.project.id)"
                                :clearable="false"
                              >
                              </v-select>
                              <small class="text-danger">{{ errors[0] }}</small>
                            </validation-provider>
                          </b-form-group>

                          <b-form-group
                            label="Descuento"
                            label-for="discount"
                          >
                            <validation-provider
                                #default="{ errors }"
                                name="proyecto"
                                rules="required"
                              >
                                <b-form-input
                                  :state="errors.length > 0 ? false:null"
                                  v-model="invoiceData.discount"
                                  type="number"
                                  maxlength="2"
                                  onKeyUp=" if (this.value.length > 2) {this.value = this.value.slice(0, 2)} if(this.value<0){this.value= this.value * -1}"
                                />
                                 <small class="text-danger">{{ errors[0] }}</small>
                            </validation-provider>
                          </b-form-group>
                        </div>
                      </b-col>

                      <!-- Col: Payment Details -->
                      <b-col
                        cols="12"
                        xl="6"
                        class="mb-lg-1"
                      >
                        <div class="mt-2">
                          <b-form-group
                            label="Moneda"
                            label-for="payment-method"
                          >
                            <validation-provider
                              #default="{ errors }"
                              name="moneda"
                              rules="required"
                            >
                              <v-select
                                v-model="invoiceData.currencyType"
                                :options="currencyType"
                                disabled
                                :state="errors.length > 0 ? false:null"
                                input-id="payment-type"
                                class="payment-selector"
                                :clearable="false"
                                @input="taxes"
                              />
                              <small class="text-danger">{{ errors[0] }}</small>
                            </validation-provider>
                          </b-form-group>

                          <b-form-group
                            label="Tipo de pago"
                            label-for="payment-method"
                          >
                            <v-select
                              v-model="invoiceData.paymentType"
                              :options="paymentType"
                              input-id="payment-type"
                              class="payment-selector"
                              :clearable="false"
                            />
                          </b-form-group>
                          <b-form-group
                            label="Condiciones de pago"
                            label-for="payment-method"
                          >
                            <b-form-textarea v-model="invoiceData.paymentConditions" />
                          </b-form-group>
                        </div>
                      </b-col>
                    </b-row>
                  </b-card-body>
      <!-- --------------------------------------- -->
                  <!-- Items Section -->
                  <b-card-body class="invoice-padding form-item-section" >
                    <div
                      ref="form"
                      class="repeater-form"
                      :style="{height: trHeight}"
                    >
                      <b-row
                        v-for="(item, index) in invoiceData.items"
                        :id="item.id"
                        :key="index"
                        ref="row"
                        class="pb-2"
                      >
                        <!-- Item Form -->
                        <!-- ? This will be in loop => So consider below markup for single item -->
                        <b-col cols="12">

                          <!-- ? Flex to keep separate width for XIcon and SettingsIcon -->
                          <div class="d-none d-lg-flex">
                            <b-row class="flex-grow-1 px-1">
                              <!-- Single Item Form Headers -->
                              <b-col
                                cols="12"
                                lg="5"
                              >
                                Actividad
                              </b-col>
                              <b-col
                                cols="12"
                                lg="3"
                              >
                                Horas Empleadas
                              </b-col>
                              <b-col
                                cols="12"
                                lg="2"
                              >
                                Costo
                              </b-col>
                              <b-col
                                cols="12"
                                lg="2"
                              >
                                Total
                              </b-col>
                            </b-row>
                            <div class="form-item-action-col" />
                          </div>

                          <!-- Form Input Fields OR content inside bordered area  -->
                          <!-- ? Flex to keep separate width for XIcon and SettingsIcon -->
                          <div class="d-flex border rounded">
                            <b-row class="flex-grow-1 p-2">
                              <!-- Single Item Form Headers -->
                              <b-col
                                cols="12"
                                lg="5"
                              >
                                <label class="d-inline d-lg-none">Actividad</label>
                                <validation-provider
                                  #default="{ errors }"
                                  name="actividad"
                                  rules="required"
                                >
                                  <v-select
                                    v-model="item.name"
                                    :options="itemsOptions"
                                    :state="errors.length > 0 ? false:null"
                                    label="name"
                                    :clearable="false"
                                    class="mb-2 item-selector-title"
                                    placeholder="Seleccionar Actividad"
                                    @input="updateItemForm(index,item.name.id)"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </validation-provider>
                              </b-col>
                              <b-col
                                cols="12"
                                lg="3"
                              >
                                <label class="d-inline d-lg-none">Horas Empleadas</label>
                                <validation-provider
                                  #default="{ errors }"
                                  name="horas"
                                  rules="required"
                                > 
                                  <b-form-input
                                    v-model="item.real_time"
                                    :state="errors.length > 0 ? false:null"
                                    type="number"
                                    class="mb-2"
                                    disabled
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </validation-provider>
                              </b-col>
                              <b-col
                                cols="12"
                                lg="2"
                              >
                                <label class="d-inline d-lg-none">Costo</label>
                                <validation-provider
                                  #default="{ errors }"
                                  name="costo"
                                  rules="required"
                                > 
                                  <b-form-input
                                    v-model="item.cost"
                                    :state="errors.length > 0 ? false:null"
                                    type="number"
                                    class="mb-2"
                                    maxlength="6"
                                    onKeyUp=" if (this.value.length > 6) {this.value = this.value.slice(0, 6)} if(this.value<0){this.value= this.value * -1}"
                                    @input="totalPerActivitie(index)"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </validation-provider>
                              </b-col>
                              <b-col
                                cols="12"
                                lg="2"
                              >
                                <label class="d-inline d-lg-none">Total</label>
                                <p class="mb-1">
                                  ${{ item.total }}
                                </p>
                              </b-col>
                            </b-row>
                            <div class="d-flex flex-column justify-content-between border-left py-50 px-25">
                              <feather-icon
                                size="16"
                                icon="XIcon"
                                class="cursor-pointer"
                                @click="removeItem(index)"
                              />
                              
                            </div>
                          </div>
                        </b-col>
                      </b-row>
                    </div>
                    <b-button
                      v-ripple.400="'rgba(255, 255, 255, 0.15)'"
                      size="sm"
                      variant="primary"
                      @click="addNewItemInItemForm"
                      v-show="itemsOptions.length !==0"
                    >
                    <feather-icon icon="PlusIcon" />
                      Actividad
                    </b-button>
                  </b-card-body>

                  <!-- Invoice Description: Total -->
                  <b-card-body class="invoice-padding pb-0">
                    <b-row v-show="invoiceData.currencyType==='MXN'">

                        <!-- Col: Total MXN-->
                        <b-col
                          cols="12"
                          md="12"
                          class="mt-md-6 d-flex justify-content-end"

                         
                        >
                          <div class="invoice-total-wrapper" >
                            <div class="invoice-total-item">
                            </div>
                            <div class="invoice-total-item">
                              <p class="invoice-total-title">
                                Subtotal:
                              </p>
                              <p class="invoice-total-amount">
                                <label>{{baseAmount}}</label>
                                
                              </p>
                            </div>
                            <div class="invoice-total-item">
                              <p class="invoice-total-title">
                                Descuento:
                              </p>
                              <p class="invoice-total-amount">
                                {{discountAmount}}
                              </p>
                            </div>
                            <div class="invoice-total-item" >
                              <p class="invoice-total-title">
                                IVA (16%):
                              </p>
                              <p class="invoice-total-amount">
                                {{taxesAmount}}
                              </p>
                            </div>
                            <hr class="my-50">
                            <div class="invoice-total-item">
                              <p class="invoice-total-title">
                                Total:
                              </p>
                              <p class="invoice-total-amount">
                                ${{totalAmount}}
                              </p>
                            </div>
                          </div>
                        </b-col>
                    </b-row>
                    <b-row v-show="invoiceData.currencyType==='USD'">

                        <!-- Col: Total USD-->

                        <b-col
                          cols="12"
                          md="6"
                          class="mt-md-6 d-flex justify-content-end"
                          order="3"
                          order-md="3"
                        >
                          <div class="invoice-total-wrapper" >
                            <div class="invoice-total-item">
                              <p class="invoice-total-title">
                                Subtotal:
                              </p>
                              <p class="invoice-total-amount">
                                {{baseAmountUsd}}
                              </p>
                            </div>
                            <div class="invoice-total-item">
                              <p class="invoice-total-title">
                                Descuento:
                              </p>
                              <p class="invoice-total-amount">
                                {{discountAmountUsd}}
                              </p>
                            </div>
                            <div class="invoice-total-item">
                              <p class="invoice-total-title">
                                Imppuesto (5.6%):
                              </p>
                              <p class="invoice-total-amount">
                                {{taxesAmountUsd}}
                              </p>
                            </div>
                            <hr class="my-50">
                            <div class="invoice-total-item">
                              <p class="invoice-total-title">
                                Total (USD):
                              </p>
                              <p class="invoice-total-amount">
                                ${{totalAmountUsd}}
                              </p>
                            </div>
                          </div>
                        </b-col>

                        <!-- Col: Total MXN-->
                        <b-col
                          cols="12"
                          md="6"
                          class="mt-md-6 d-flex justify-content-end"
                          order="2"
                          order-md="2"
                        >
                          <div class="invoice-total-wrapper" >
                            <div class="invoice-total-item">
                            </div>
                            <div class="invoice-total-item">
                              <p class="invoice-total-title">
                                Subtotal:
                              </p>
                              <p class="invoice-total-amount">
                                <label>{{baseAmount}}</label>
                                
                              </p>
                            </div>
                            <div class="invoice-total-item">
                              <p class="invoice-total-title">
                                Descuento:
                              </p>
                              <p class="invoice-total-amount">
                                {{discountAmount}}
                              </p>
                            </div>
                            <div class="invoice-total-item" >
                              <p class="invoice-total-title">
                                Impuesto (5.6%):
                              </p>
                              <p class="invoice-total-amount">
                                {{taxesAmount}}
                              </p>
                            </div>
                            <hr class="my-50">
                            <div class="invoice-total-item">
                              <p class="invoice-total-title">
                                Total (MXN):
                              </p>
                              <p class="invoice-total-amount">
                                ${{totalAmount}}
                              </p>
                            </div>
                          </div>
                        </b-col>

                    </b-row>
                  </b-card-body> 

                  <!-- Spacer -->
                  <hr class="invoice-spacing">

                  <!-- Note -->
                  <b-col
                    cols="12"
                    md="6"
                    xl="3"
                    class="mt-md-6 d-flex justify-content-end"
                  >
                    <b-card-body class="invoice-padding pt-0">
                      <b-button
                        v-ripple.400="'rgba(113, 102, 240, 0.15)'"
                        variant="primary"
                        block
                        @click="saveInvoice()"
                      >
                        Guardar
                      </b-button>
                    </b-card-body>
                  </b-col>
                </b-card>
              </b-form>
            </validation-observer>
          </b-col>
        </b-row>
      </section>
    </b-card>
  </div>
</template>

<script>
import Logo from '@core/layouts/components/Logo.vue'
import { heightTransition } from '@core/mixins/ui/transition'
import Ripple from 'vue-ripple-directive'
import { ValidationProvider, ValidationObserver } from 'vee-validate'
import { required } from '@validations'
import {
  BRow, BCol, BCard, BCardBody, BButton, BCardText, BForm, BFormGroup, BFormInput, BInputGroup, BInputGroupPrepend, BFormTextarea, BFormCheckbox, BPopover, VBToggle,
} from 'bootstrap-vue'
import vSelect from 'vue-select'

export default {
  components: {
    BRow,
    BCol,
    BCard,
    BCardBody,
    BButton,
    BCardText,
    BForm,
    BFormGroup,
    BFormInput,
    BInputGroup,
    BInputGroupPrepend,
    BFormTextarea,
    BFormCheckbox,
    BPopover,
    vSelect,
    Logo,
    ValidationProvider, 
    ValidationObserver
  },
  directives: {
    Ripple,
    'b-toggle': VBToggle,

  },
  mixins: [heightTransition],

  data(){
    return{  
      clients:[],
      projects:[],
      itemsOptions:[],
      selectedClient:'',
      itemFormBlankItem: {
        id: 0,
        name: '',
        real_time: 0,
        cost: 0,
        total:0
      },
      invoiceData:{
        quoteDate:'',
        project:'',
        client:'',
        discount:0,
        paymentType:'',
        paymentConditions:'',
        currencyType:null,
        conversion_rate:null,
        base_amount:0,
        taxes_id:null,
        total_amount:0,
        taxes_amount:0,
        items: []
      },
      taxe:'',
      base_amount:0,
      total_amount:0,
      taxes_amount:0,
      discount_amount:0,

      base_amount_usd:0,
      total_amount_usd:0,
      taxes_amount_usd:0,
      discount_amount_usd:0,
     
      currencyType:[
        'MXN',
        'USD',
      ],
      paymentType:[
        'Cuenta de banco',
        'PayPal',
        'Referencia',
      ],

    }
  },
  methods: {
    getClients(){
      this.$http.get('client/invoice').then(res=>{
        this.clients = res.data.clients
      }).catch(err=>{
        console.log(err);
      })
    },
    getProjects(id){
      this.invoiceData.currencyType=this.selectedClient.currency_type
      this.taxes()

      this.initTrHeight()
      this.invoiceData.items=[]
      this.invoiceData.items.push(JSON.parse(JSON.stringify(this.itemFormBlankItem)))
      
      this.projects=[]
      this.invoiceData.project=''

      this.$http.get('project/showProjectName',{ params:{id:id}}).then(res=>{
        this.projects = res.data.project
      }).catch(err=>{
        console.log(err);
      })
    },
    getActivities(id){
      this.initTrHeight()
      this.invoiceData.items=[]
      this.invoiceData.items.push(JSON.parse(JSON.stringify(this.itemFormBlankItem)))

      this.$http.get('activities/showActivitiesInvoice',{ params:{id:id}}).then(res=>{
        this.itemsOptions=res.data.activities
        // console.log(this.activitiesLength);
      }).catch(err=>{
        console.log(err);
      })
    },
    updateItemForm(index, idActivitie){
      let activitie = this.itemsOptions.find( activitie => activitie.id ===  idActivitie)
      
      let i;
      for(i in this.itemsOptions){
        if(this.itemsOptions[i].id===activitie.id){
          this.itemsOptions.splice(i, 1)
        }
      }
      this.invoiceData.items[index].id = activitie.id
      this.invoiceData.items[index].name = activitie.name
      this.invoiceData.items[index].real_time = activitie.real_time
      this.invoiceData.items[index].cost = this.itemFormBlankItem.cost
      this.invoiceData.items[index].total = 0
    },
    totalPerActivitie(index){
      this.invoiceData.items[index].total = this.invoiceData.items[index].real_time * this.invoiceData.items[index].cost
    },
    taxes(){
       this.$http.get('taxe/taxeValue',{ params:{currency:this.invoiceData.currencyType}}).then(res=>{
        this.invoiceData.taxes_id=res.data.taxe.id;
        this.taxe=res.data.taxe.taxValue;
      }).catch(err=>{
        console.log(err);
      })
      
      if (this.invoiceData.currencyType==='USD'){
        this.$http.get('https://freecurrencyapi.net/api/v2/latest?apikey=61de1330-69c4-11ec-88b2-6faa86b3ccc7&base_currency=USD').then(res=>{
          this.invoiceData.conversion_rate = Number.parseFloat(res.data.data.MXN).toFixed(2)
        }).catch(err=>{
          console.log(err);
        })
      }
    },
    addNewItemInItemForm() {
        this.$refs.form.style.overflow = 'hidden'
        this.invoiceData.items.push(JSON.parse(JSON.stringify(this.itemFormBlankItem)))

        this.$nextTick(() => {
          this.trAddHeight(this.$refs.row[0].offsetHeight)
          setTimeout(() => {
            this.$refs.form.style.overflow = null
          }, 350)
        })
    },
    removeItem(index) {
      let activitie= this.invoiceData.items[index]
      this.itemsOptions.push(activitie)
  
      this.invoiceData.items.splice(index, 1)

      this.trTrimHeight(this.$refs.row[0].offsetHeight)
    },
    initTrHeight() {
      this.trSetHeight(null)
      this.$nextTick(() => {
        this.trSetHeight(this.$refs.form.scrollHeight)
      })
    },
    saveInvoice(){
      this.$refs.simpleRules.validate().then(success => {
        if (success) {
          this.invoiceData.client=this.selectedClient
          if(this.invoiceData.currencyType==='MXN'){
            this.invoiceData.base_amount=this.base_amount
            this.invoiceData.taxes_amount=this.taxes_amount
            this.invoiceData.total_amount=this.total_amount
          }else{
            this.invoiceData.base_amount=this.base_amount_usd
            this.invoiceData.taxes_amount=this.taxes_amount_usd
            this.invoiceData.total_amount=this.total_amount_usd
          }
          this.$http.post('invoice/create',this.invoiceData).then(res =>{
            // console.log(res)
            if (res.data.message === "agregado") {
                this.$router.push({ name: "apps-invoice-list" });
              }
          }).catch(err=>{
            console.log(err);
          })
        }
      })
    }
  },
  computed:{
    baseAmount(){
      if(this.invoiceData.currencyType==='MXN'){
        
        this.base_amount=0
        let i;
        for(i in this.invoiceData.items){
          this.base_amount+=this.invoiceData.items[i].total
        }
        return  Number.parseFloat(this.base_amount).toFixed(2)
      }else{
        this.base_amount=0
        return this.base_amount = Number.parseFloat(this.base_amount_usd * Number.parseFloat(this.invoiceData.conversion_rate).toFixed(2) ).toFixed(2)
      }  
    },
    discountAmount(){
      if(this.invoiceData.currencyType==='MXN'){
        return this.discount_amount=Number.parseFloat((this.invoiceData.discount / 100) * this.base_amount).toFixed(2);
      }else{
         this.discount_amount=0
        return this.discount_amount=Number.parseFloat(this.discount_amount_usd * Number.parseFloat(this.invoiceData.conversion_rate).toFixed(2)).toFixed(2);
      }
    },
    taxesAmount(){
      if(this.invoiceData.currencyType==='MXN'){
        if (this.discount_amount!==0){
          return this.taxes_amount = Number.parseFloat((this.base_amount - this.discount_amount) * this.taxe).toFixed(2);
        }else{
          return this.taxes_amount = Number.parseFloat(this.base_amount * this.taxe).toFixed(2);
        }
      }else{
        return this.taxes_amount = Number.parseFloat(this.taxes_amount_usd * Number.parseFloat(this.invoiceData.conversion_rate).toFixed(2)).toFixed(2);
      }
    },
    totalAmount(){
      this.total_amount=0
      if(this.invoiceData.currencyType==='MXN'){
        return this.total_amount = Number.parseFloat(Number.parseFloat(this.base_amount) - Number.parseFloat(this.discount_amount) + Number.parseFloat(this.taxes_amount)).toFixed(2)
      }else{
        return this.total_amount= Number.parseFloat(this.total_amount_usd * Number.parseFloat(this.invoiceData.conversion_rate).toFixed(2) ).toFixed(2)
      }
    },
    baseAmountUsd(){

      this.base_amount_usd=0
      let i;
      for(i in this.invoiceData.items){
        this.base_amount_usd+=this.invoiceData.items[i].total
      }
      return  Number.parseFloat(this.base_amount_usd).toFixed(2)
      
    },
    discountAmountUsd(){
      this.discount_amount_usd=0
      return this.discount_amount_usd=Number.parseFloat((this.invoiceData.discount / 100) * this.base_amount_usd).toFixed(2);
    },
    taxesAmountUsd(){
      this.taxes_amount_usd=0
      if (this.discount_amount_usd!==0){
        return this.taxes_amount_usd = Number.parseFloat((this.base_amount_usd - this.discount_amount_usd) * this.taxe).toFixed(2);
      }else{
        return this.taxes_amount_usd = Number.parseFloat(this.base_amount_usd * this.taxe).toFixed(2);
      }
    },
    totalAmountUsd(){
      return this.total_amount_usd = Number.parseFloat(Number.parseFloat(this.base_amount_usd) - Number.parseFloat(this.discount_amount_usd) + Number.parseFloat(this.taxes_amount_usd) ).toFixed(2);
    }
  },
  mounted() {
    this.getClients()
    this.initTrHeight()
    this.invoiceData.items.push(JSON.parse(JSON.stringify(this.itemFormBlankItem)))
    var today = new Date();
    this.invoiceData.quoteDate = today.getFullYear()+'-'+(today.getMonth()+1)+'-'+today.getDate();
  },
  created() {
    window.addEventListener('resize', this.initTrHeight)
  },
  destroyed() {
    window.removeEventListener('resize', this.initTrHeight)
  },
}
</script>

<style lang="scss">
@import '@core/scss/vue/libs/vue-select.scss';
@import '@core/scss/vue/libs/vue-flatpicker.scss';
.invoice-add-wrapper {
  .add-new-client-header {
    padding: $options-padding-y $options-padding-x;
      color: $success;

    &:hover {
      background-color: rgba($success, 0.12);
    }
  }
}
</style>

<style lang="scss" scoped>
@import "~@core/scss/base/pages/app-invoice.scss";
@import '~@core/scss/base/components/variables-dark';

.form-item-section {
background-color:$product-details-bg;
}

.form-item-action-col {
  width: 27px;
}

.repeater-form {
  // overflow: hidden;
  transition: .35s height;
}

.v-select {
  &.item-selector-title,
  &.payment-selector {
    background-color: #fff;

    .dark-layout & {
      background-color: unset;
    }
  }
}

.dark-layout {
  .form-item-section {
    background-color: $theme-dark-body-bg;

    .row .border {
      background-color: $theme-dark-card-bg;
    }

  }
}
</style>
